package xmlx

import (
	"encoding/xml"
	"github.com/hsiafan/glow/stringx"
)

// Marshal encode value to xml formatted string
func Marshal(v interface{}) (string, error) {
	data, err := xml.Marshal(v)
	if err != nil {
		return "", err
	}
	return stringx.FromBytes(data), nil
}

// MarshalIndent marshal value to xml string, with indent for each element
func MarshalIndent(v interface{}, indent string) (string, error) {
	data, err := xml.MarshalIndent(v, "", indent)
	if err != nil {
		return "", err
	}
	return stringx.FromBytes(data), nil
}

// Unmarshal parse the xml encoded string, store into value
func Unmarshal(s string, v interface{}) error {
	return xml.Unmarshal(stringx.ToBytes(s), v)
}
